/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_IDENTIFIANTS__
#define __INVESTIGATION_DONNEES_IDENTIFIANTS__

#include <map>
#include <set>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(Identifiant); } }

namespace Investigation
{
	namespace Donnees
	{
		struct Identifiant
		{
			bool operator==(const Identifiant& id) const
			{
				return _valeur==id._valeur;
			}
			bool operator<(const Identifiant& id) const
			{
				return _valeur<id._valeur;
			}
			Identifiant()
			:_valeur(0)
			{
				static Compteur compteur;
				_valeur = compteur._compteur++;
			};
			operator size_t () const
			{
				return _valeur;
			}
			private:
				struct Compteur
				{
					Compteur()
					:_compteur(0) {};
					size_t _compteur;
				};
				size_t _valeur;
		};

		struct IdentifiantPagesActives
		{
			IdentifiantPagesActives() = default;
			IdentifiantPagesActives(const std::string& mot_clef, const Identifiant& identifiant);
			void operator+=(const IdentifiantPagesActives& identifiants_pages_actives);
			std::map<std::string, std::set<Identifiant> > _identifiants_pages_actives;
		};
	}
}
#endif
