/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_TEXTE__
#define __INVESTIGATION_DONNEES_TEXTE__

#include <vector>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(Texte); } }
#include <src/investigation/donnees/page.h>
#include <src/investigation/donnees/html.h>

namespace Investigation
{
	namespace Donnees
	{
		class Texte : public ContenuPage
		{
			public:
				explicit Texte(const std::string& texte);
				virtual ~Texte();
				virtual Html::SequenceContenuDiv operator() (const std::string& methode, const Requete& requete, Liens& liens) const;
				virtual ContenuPageSP clone() const;
				virtual bool operator%(const ContenuPage& contenu_page) const;
				bool operator%(const Texte& texte) const;
				virtual void liens_valides(const std::set<std::string>& identifiants) const;
				virtual void propage_infos(const std::string& page);
				virtual long int niveau_information() const;
				virtual void compte(CompteursSite& compteurs) const;
				virtual IdentifiantPagesActives pages_actives_source(const Identifiant& page) const;
			private:
				std::string _texte;
		};
	}
}
#endif
